#pragma once
#include "afx.h"
#include "ipl.h"
//#include "cv.h"

//#include "..\General\ZoomDC.h"

class CIplImageCapsuleDlg;

class AFX_EXT_CLASS CIplImageCapsule :
	public CObject
{
	DECLARE_SERIAL(CIplImageCapsule)

protected:
	BITMAPINFO*				m_bmi;
	BITMAPINFO*				m_gsBmi;
	IplImage*				m_iplImage;
	IplImage*				m_gsImage;
	bool					m_allocatedImageData;
	CIplImageCapsuleDlg*	m_parentDlg;

public:
	CIplImageCapsule(void);
	virtual ~CIplImageCapsule(void);

	__inline IplImage* GetColorImage() {return m_iplImage;}
	__inline IplImage* GetGSImage() {return m_gsImage;}
	__inline BITMAPINFO* GetColorBitmapInfo() {return m_bmi;}
	__inline BITMAPINFO* GetGSBitmapInfo() {return m_gsBmi;}
	__inline void SetParentDlg(CIplImageCapsuleDlg* parentDlg) {m_parentDlg = parentDlg;}

	virtual bool GetFromFile(CFile* file);
	virtual bool GetFromFile(CString fileName);
	virtual void DrawToDC(CZoomDC* dc, bool color = true);
	virtual void StretchToDC(CZoomDC* dc, bool color = true);
	virtual void InitBitmapInfos(int width, int height, bool initGSImage = true);
	virtual void InitImages(int width, int height, bool allocateImage = true, bool initGSImage = true);
	virtual void Clear();
	virtual void Serialize(CArchive& archive);
	virtual int GetFromIplImage(IplImage* iplImage);
	virtual bool SaveToFile(CString filename, bool colorImage);
};
