#include "StdAfx.h"
#include "iplimagecapsuledlg.h"
#include "..\General\MemDC.h"
#include ".\iplimagecapsuledlg.h"
IMPLEMENT_SERIAL(CIplImageCapsuleDlg, CContainerDlg,1);

CIplImageCapsuleDlg::CIplImageCapsuleDlg(CWnd* pParent)
	: CContainerDlg(/*pParent*/)
	, m_iplImageCapsule(NULL)
	, m_showColor(FALSE)
	, m_iplImageCapsuleLocal(NULL)
	, m_stretchMode(TRUE)
{
}

CIplImageCapsuleDlg::~CIplImageCapsuleDlg(void)
{
	if(m_iplImageCapsuleLocal)
		delete m_iplImageCapsuleLocal;
	m_iplImageCapsuleLocal = NULL;
}

void CIplImageCapsuleDlg::DrawImage(CZoomDC* dc)
{
	if (m_showColor && m_iplImageCapsule->GetColorImage() == NULL)
		return;
	else if (!m_showColor && m_iplImageCapsule->GetGSImage() == NULL)
		return;
	else if (m_iplImageCapsule)
	{
		DrawRulers(dc);
		if (m_doClipping)
		{
			CRect r;
			GetClientRect(&r);
			dc->m_dc->IntersectClipRect(dc->m_topLeftOffset.cx, dc->m_topLeftOffset.cy, r.Width(), r.Height());
		}
		if (m_stretchMode)
			m_iplImageCapsule->StretchToDC(dc, m_showColor);
		else
			m_iplImageCapsule->DrawToDC(dc, m_showColor);
	}
}

void CIplImageCapsuleDlg::SetImage(CIplImageCapsule* iplImageCapsule)
{
	bool erase = false;
	if (m_iplImageCapsule == NULL || iplImageCapsule == NULL || 
		m_iplImageCapsule->GetColorImage() == NULL || 
		iplImageCapsule->GetColorImage() == NULL || 
		m_iplImageCapsule->GetColorImage()->width != iplImageCapsule->GetColorImage()->width || 
		m_iplImageCapsule->GetColorImage()->height != iplImageCapsule->GetColorImage()->height)
	{
		erase = true;
	}

	if (iplImageCapsule == NULL)
	{
		CClientDC dc(this);

		HGDIOBJ old_br, old_pen;
		int old_rop2;

		old_rop2 = dc.SetROP2(R2_COPYPEN);
		old_br = SelectObject(dc.m_hDC, GetStockObject(WHITE_BRUSH));
		old_pen = SelectObject(dc.m_hDC, &CPen(PS_SOLID, 0, RGB(255, 0, 0)));

		dc.Rectangle(0, 0, 2000, 2000);

		dc.SetROP2(old_rop2);
		SelectObject(dc.m_hDC, old_br);
		SelectObject(dc.m_hDC, old_pen);
	}

	m_iplImageCapsule = iplImageCapsule;

	SetSBars();
	Invalidate(erase);
}

void CIplImageCapsuleDlg::SetSBars()
{
	if (m_iplImageCapsule == NULL || m_iplImageCapsule->GetColorImage() == NULL)
		SetClientSize(0, 0);
	else
		SetClientSize(m_iplImageCapsule->GetColorImage()->width,m_iplImageCapsule->GetColorImage()->height);
}

BEGIN_MESSAGE_MAP(CIplImageCapsuleDlg, CContainerDlg)
	ON_WM_PAINT()
	ON_WM_ERASEBKGND()
END_MESSAGE_MAP()

void CIplImageCapsuleDlg::OnPaint()
{
	CPaintDC dc(this); // device context for painting
	CMemDC memDC(&dc);
	m_zoomDC.m_dc = &memDC;

	if (m_iplImageCapsule)
		DrawImage(&m_zoomDC);
}

void CIplImageCapsuleDlg::Update(CRect* invRect) 
{
	if(invRect)
		InvalidateRect(invRect, false);
	else
		Invalidate(false);
	RedrawWindow(invRect);
	SendMessage(WM_PAINT);
};

void CIplImageCapsuleDlg::SetIplImage(IplImage* image)
{
	if(!m_iplImageCapsuleLocal)
		m_iplImageCapsuleLocal = new CIplImageCapsule;
	m_iplImageCapsuleLocal->GetFromIplImage(image);
	m_iplImageCapsule = NULL;
	SetImage(m_iplImageCapsuleLocal);
}
BOOL CIplImageCapsuleDlg::OnEraseBkgnd(CDC* pDC)
{
	// TODO: Add your message handler code here and/or call default

	return true;//CContainerDlg::OnEraseBkgnd(pDC);
}
