#pragma once

//#include <gdiplus.h>
#include <ipl.h>

// libraries
#pragma comment (lib, "ipl.lib")
#undef UINT16
#include <gdiplus.h>
#pragma comment (lib, "gdiplus.lib")

using namespace Gdiplus;

// CIplImageLoader command target
class CIplImageLoader : public CObject
{
protected:
	Bitmap* m_pBitmap;
	IplImage* m_iplImage;
	BITMAPINFO* m_bmi;
	char* m_dibData;
	bool m_isImageLoaded;

	void BmpToIpl();
	void IplToBmp();
	void UpdateBitmapInfo(IplImage* image);
	CString GetFormatString(CString fileFormat);
	int GetEncoderClsid(const WCHAR* format, CLSID* pClsid);

public:
	CIplImageLoader();
	virtual ~CIplImageLoader();

	bool IsImageLoaded();

	IplImage* GetIplImage();
	void ResetIplImage(IplImage* iplImage = NULL);

	bool LoadImage(CString filename);
	bool SaveImage(CString filename, CString format);

	bool DrawImage(CDC* dc, IplImage* image = NULL, int x = 0, int y = 0);
	bool StretchImage(CDC* dc, CRect rect, IplImage* image = NULL);
};


